Index: /branches/2014/dev_r4650_UKMO7_STARTHOUR/NEMOGCM/TOOLS/SIREN/src/grid.f90
===================================================================
--- /branches/2014/dev_r4650_UKMO7_STARTHOUR/NEMOGCM/TOOLS/SIREN/src/grid.f90	(revision 5074)
+++ /branches/2014/dev_r4650_UKMO7_STARTHOUR/NEMOGCM/TOOLS/SIREN/src/grid.f90	(revision 5075)
@@ -576,85 +2029,78 @@
 
       ! init
-      grid_get_coarse_index_ff(:,:,:)=0
-
-      ALLOCATE(il_rho(ig_ndim))
+      grid__get_coarse_index_ff(:,:)=0
+
+      ALLOCATE(il_rho(ip_maxdim))
       il_rho(:)=1
       IF( PRESENT(id_rho) ) il_rho(:)=id_rho(:)
 
-      IF( td_coord0%i_id == 0 .OR. td_coord1%i_id == 0 )THEN
-         CALL logger_error("GRID GET COARSE INDEX: can not get corase "//&
-         &  "grid indices. file "//TRIM(td_coord0%c_name)//" and/or "//&
-         &   TRIM(td_coord1%c_name)//" not opened." )
+      cl_point='T'
+      IF( PRESENT(cd_point) ) cl_point=TRIM(fct_upper(cd_point))
+
+      ! copy structure
+      tl_coord0=mpp_copy(td_coord0)
+      tl_coord1=mpp_copy(td_coord1)
+
+      IF( .NOT. ASSOCIATED(tl_coord0%t_proc) .OR. &
+      &   .NOT. ASSOCIATED(tl_coord1%t_proc) )THEN
+         CALL logger_error("GRID GET COARSE INDEX: can not get coarse "//&
+         &  "grid indices. decompsition of mpp file "//TRIM(tl_coord0%c_name)//&
+         &  " and/or "//TRIM(tl_coord1%c_name)//" not defined." )
       ELSE
-         !1- Coarse grid
+         ! Coarse grid
+         ! get ghost cell factor on coarse grid
+         il_xghost0(:,:)=grid_get_ghost( tl_coord0 )
+
+         ! open mpp files
+         CALL iom_mpp_open(tl_coord0)
+
          ! read coarse longitue and latitude
-         tl_lon0=iom_read_var(td_coord0,'longitude')
-         tl_lat0=iom_read_var(td_coord0,'latitude')
-
-         ! get ghost cell factor on coarse grid
-         il_xghost0(:)=grid_get_ghost( tl_lon0, tl_lat0 )
-
-         il_imin0=1+il_xghost0(1)*ig_ghost
-         il_jmin0=1+il_xghost0(2)*ig_ghost
-
-         il_imax0=tl_lon0%t_dim(1)%i_len-il_xghost0(1)*ig_ghost
-         il_jmax0=tl_lon0%t_dim(2)%i_len-il_xghost0(2)*ig_ghost
-
-         CALL var_clean(tl_lon0)
-         CALL var_clean(tl_lat0)
-
-         ! read coarse longitue and latitude without ghost cell
-         il_start(:)=(/il_imin0,il_jmin0,1,1/)
-         il_count(:)=(/il_imax0-il_imin0+1, &
-         &             il_jmax0-il_jmin0+1, &
-         &             tl_lon0%t_dim(3)%i_len, &
-         &             tl_lon0%t_dim(4)%i_len /)
-
-         tl_lon0=iom_read_var(td_coord0,'longitude',il_start(:), il_count(:))
-         tl_lat0=iom_read_var(td_coord0,'latitude' ,il_start(:), il_count(:))
+         WRITE(cl_name,*) 'longitude_'//TRIM(cl_point)
+         tl_lon0=iom_mpp_read_var(tl_coord0, TRIM(cl_name))
+         WRITE(cl_name,*) 'latitude_'//TRIM(cl_point)
+         tl_lat0=iom_mpp_read_var(tl_coord0, TRIM(cl_name))
          
-         !2- Fine grid
+         CALL grid_del_ghost(tl_lon0, il_xghost0(:,:))
+         CALL grid_del_ghost(tl_lat0, il_xghost0(:,:))
+
+         ! close mpp files
+         CALL iom_mpp_close(tl_coord0)
+
+         ! Fine grid
+
+         ! get ghost cell factor on fine grid
+         il_xghost1(:,:)=grid_get_ghost( tl_coord1 )
+
+         ! open mpp files
+         CALL iom_mpp_open(tl_coord1)
+
          ! read fine longitue and latitude
-         tl_lon1=iom_read_var(td_coord1,'longitude')
-         tl_lat1=iom_read_var(td_coord1,'latitude')
-
-         ! get ghost cell factor on fine grid
-         il_xghost1(:)=grid_get_ghost( tl_lon1, tl_lat1 )
-
-         il_imin1=1+il_xghost1(1)*ig_ghost
-         il_jmin1=1+il_xghost1(2)*ig_ghost
-
-         il_imax1=tl_lon1%t_dim(1)%i_len-il_xghost1(1)*ig_ghost
-         il_jmax1=tl_lon1%t_dim(2)%i_len-il_xghost1(2)*ig_ghost
-
-         CALL var_clean(tl_lon1)
-         CALL var_clean(tl_lat1)
-
-         ! read fine longitue and latitude without ghost cell
-         il_start(:)=(/il_imin1,il_jmin1,1,1/)
-         il_count(:)=(/il_imax1-il_imin1+1, &
-         &             il_jmax1-il_jmin1+1, &
-         &             tl_lon1%t_dim(3)%i_len, &
-         &             tl_lon1%t_dim(4)%i_len /)
-
-         tl_lon1=iom_read_var(td_coord1,'longitude',il_start(:), il_count(:))
-
-         tl_lat1=iom_read_var(td_coord1,'latitude' ,il_start(:), il_count(:))
+         WRITE(cl_name,*) 'longitude_'//TRIM(cl_point)
+         tl_lon1=iom_mpp_read_var(tl_coord1, TRIM(cl_name)) 
+         WRITE(cl_name,*) 'latitude_'//TRIM(cl_point)
+         tl_lat1=iom_mpp_read_var(tl_coord1, TRIM(cl_name))
  
-         !3- compute
-         
-         grid_get_coarse_index_ff(:,:,:)=grid_get_coarse_index(tl_lon0,tl_lat0,&
-         &                                                     tl_lon1,tl_lat1,&
-         &                                                     il_rho(:) )
-
-         il_imin0=grid_get_coarse_index_ff(1,1,1)-il_xghost0(1)*ig_ghost
-         il_imax0=grid_get_coarse_index_ff(1,2,1)+il_xghost0(1)*ig_ghost
-         il_jmin0=grid_get_coarse_index_ff(2,1,1)-il_xghost0(2)*ig_ghost
-         il_jmax0=grid_get_coarse_index_ff(2,2,1)+il_xghost0(2)*ig_ghost
-
-         grid_get_coarse_index_ff(1,1,1)=il_imin0
-         grid_get_coarse_index_ff(1,2,1)=il_imax0
-         grid_get_coarse_index_ff(2,1,1)=il_jmin0
-         grid_get_coarse_index_ff(2,2,1)=il_jmax0
+         CALL grid_del_ghost(tl_lon1, il_xghost1(:,:))
+         CALL grid_del_ghost(tl_lat1, il_xghost1(:,:))
+
+         ! close mpp files
+         CALL iom_mpp_close(tl_coord1)
+
+         ! compute
+         grid__get_coarse_index_ff(:,:)=grid_get_coarse_index(tl_lon0,tl_lat0,&
+         &                                                    tl_lon1,tl_lat1,&
+         &                                                    il_rho(:) )
+
+         ! add ghost cell to indices
+         il_imin0=grid__get_coarse_index_ff(1,1)+il_xghost0(jp_I,1)*ip_ghost
+         il_imax0=grid__get_coarse_index_ff(1,2)+il_xghost0(jp_I,1)*ip_ghost
+
+         il_jmin0=grid__get_coarse_index_ff(2,1)+il_xghost0(jp_J,1)*ip_ghost
+         il_jmax0=grid__get_coarse_index_ff(2,2)+il_xghost0(jp_J,1)*ip_ghost
+
+         grid__get_coarse_index_ff(jp_I,1)=il_imin0
+         grid__get_coarse_index_ff(jp_I,2)=il_imax0
+         grid__get_coarse_index_ff(jp_J,1)=il_jmin0
+         grid__get_coarse_index_ff(jp_J,2)=il_jmax0
 
          CALL var_clean(tl_lon0)
@@ -665,34 +2111,49 @@
       ENDIF
 
-   END FUNCTION grid_get_coarse_index_ff
-   !> @endcode
+      ! clean
+      CALL mpp_clean(tl_coord0)
+      CALL mpp_clean(tl_coord1)
+      DEALLOCATE(il_rho)
+
+   END FUNCTION grid__get_coarse_index_ff
    !-------------------------------------------------------------------
    !> @brief This function get closest coarse grid indices of fine grid domain.
    !
    !> @details
-   !>
-   !
+   !> it use coarse array of longitude and latitude and fine grid coordinates file.
+   !> optionaly, you could specify the array of refinment factor (default 1.)
+   !> optionally, you could specify on which Arakawa grid point you want to
+   !> work (default 'T')
+   !>
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] td_longitude0 : coarse grid longitude
-   !> @param[in] td_latitude0  : coarse grid latitude
-   !> @param[in] td_coord1 : fine grid coordinate structure
-   !> @return coarse grid indices (/ (/imin0, imax0/), (/jmin0, jmax0/) /)
-   !-------------------------------------------------------------------
-   !> @code
-   FUNCTION grid_get_coarse_index_cf( td_lon0, td_lat0, td_coord1, &
-   &                                  id_rho )
+   !> - November, 2013- Initial Version
+   !> @date September, 2014
+   !> - use grid point to read coordinates variable.
+   !> @date October, 2014
+   !> - work on mpp file structure instead of file structure
+   !>
+   !> @param[in] td_longitude0   coarse grid longitude
+   !> @param[in] td_latitude0    coarse grid latitude
+   !> @param[in] td_coord1       fine grid coordinate mpp structure
+   !> @param[in] id_rho          array of refinment factor
+   !> @param[in] cd_point        Arakawa grid point (default 'T')
+   !> @return coarse grid indices (/(/imin0, imax0/), (/jmin0, jmax0/)/)
+   !-------------------------------------------------------------------
+   FUNCTION grid__get_coarse_index_cf( td_lon0, td_lat0, td_coord1, &
+   &                                   id_rho, cd_point )
       IMPLICIT NONE
       ! Argument
-      TYPE(TVAR ), INTENT(IN) :: td_lon0
-      TYPE(TVAR ), INTENT(IN) :: td_lat0
-      TYPE(TFILE), INTENT(IN) :: td_coord1
-      INTEGER(i4), DIMENSION(:), INTENT(IN), OPTIONAL :: id_rho
+      TYPE(TVAR )                   , INTENT(IN) :: td_lon0
+      TYPE(TVAR )                   , INTENT(IN) :: td_lat0
+      TYPE(TMPP )                   , INTENT(IN) :: td_coord1
+      INTEGER(i4)     , DIMENSION(:), INTENT(IN), OPTIONAL :: id_rho
+      CHARACTER(LEN=*)              , INTENT(IN), OPTIONAL :: cd_point
 
       ! function
-      INTEGER(i4), DIMENSION(2,2,2) :: grid_get_coarse_index_cf
+      INTEGER(i4), DIMENSION(2,2) :: grid__get_coarse_index_cf
 
       ! local variable
+      TYPE(TMPP)  :: tl_coord1
+
       TYPE(TVAR)  :: tl_lon1
       TYPE(TVAR)  :: tl_lat1
@@ -700,12 +2161,8 @@
       INTEGER(i4), DIMENSION(:), ALLOCATABLE :: il_rho
 
-      INTEGER(i4), DIMENSION(ip_maxdim) :: il_start
-      INTEGER(i4), DIMENSION(ip_maxdim) :: il_count
-      INTEGER(i4), DIMENSION(2)         :: il_xghost
-
-      INTEGER(i4) :: il_imin1
-      INTEGER(i4) :: il_imax1
-      INTEGER(i4) :: il_jmin1
-      INTEGER(i4) :: il_jmax1
+      INTEGER(i4), DIMENSION(2,2)       :: il_xghost
+
+      CHARACTER(LEN= 1) :: cl_point
+      CHARACTER(LEN=lc) :: cl_name
 
       ! loop indices
@@ -713,13 +2170,19 @@
 
       ! init
-      grid_get_coarse_index_cf(:,:,:)=0
-
-      ALLOCATE(il_rho(ig_ndim) )
+      grid__get_coarse_index_cf(:,:)=0
+
+      ALLOCATE(il_rho(ip_maxdim) )
       il_rho(:)=1
       IF( PRESENT(id_rho) ) il_rho(:)=id_rho(:)
 
-      IF( td_coord1%i_id == 0 )THEN
-         CALL logger_error("GRID GET COARSE INDEX: file "//&
-         &   TRIM(td_coord1%c_name)//" not opened." )
+      ! copy structure
+      tl_coord1=mpp_copy(td_coord1)
+      
+      cl_point='T'
+      IF( PRESENT(cd_point) ) cl_point=TRIM(fct_upper(cd_point))
+
+      IF( .NOT. ASSOCIATED(tl_coord1%t_proc) )THEN
+         CALL logger_error("GRID GET COARSE INDEX: decompsition of mpp "//&
+         &  "file "//TRIM(tl_coord1%c_name)//" not defined." )
 
       ELSE IF( .NOT. ASSOCIATED(td_lon0%d_value) .OR. &
@@ -731,36 +2194,35 @@
       ELSE
          
-         !1- Fine grid
+         IF( TRIM(td_lon0%c_point)/='' )THEN
+            cl_point=TRIM(td_lon0%c_point)
+         ELSEIF( TRIM(td_lat0%c_point)/='' )THEN
+            cl_point=TRIM(td_lat0%c_point)
+         ENDIF
+
+         ! Fine grid
+         ! get ghost cell factor on fine grid
+         il_xghost(:,:)=grid_get_ghost( tl_coord1 )
+
+         ! open mpp files
+         CALL iom_mpp_open(tl_coord1)
+
          ! read fine longitue and latitude
-         tl_lon1=iom_read_var(td_coord1,'longitude')
-         tl_lat1=iom_read_var(td_coord1,'latitude')
-
-         ! get ghost cell factor on fine grid
-         il_xghost(:)=grid_get_ghost( tl_lon1, tl_lat1 )
-
-         il_imin1=1+il_xghost(1)*ig_ghost
-         il_jmin1=1+il_xghost(2)*ig_ghost
-
-         il_imax1=tl_lon1%t_dim(1)%i_len-il_xghost(1)*ig_ghost
-         il_jmax1=tl_lon1%t_dim(2)%i_len-il_xghost(2)*ig_ghost
-
-         CALL var_clean(tl_lon1)
-         CALL var_clean(tl_lat1)
-
-         ! read fine longitue and latitude without ghost cell
-         il_start(:)=(/il_imin1,il_jmin1,1,1/)
-         il_count(:)=(/il_imax1-il_imin1+1, &
-         &             il_jmax1-il_jmin1+1, &
-         &             tl_lon1%t_dim(3)%i_len, &
-         &             tl_lon1%t_dim(4)%i_len /)
-
-         tl_lon1=iom_read_var(td_coord1,'longitude',il_start(:), il_count(:))
-         tl_lat1=iom_read_var(td_coord1,'latitude' ,il_start(:), il_count(:))
+         WRITE(cl_name,*) 'longitude_'//TRIM(cl_point)
+         tl_lon1=iom_mpp_read_var(tl_coord1, TRIM(cl_name))
+         WRITE(cl_name,*) 'latitude_'//TRIM(cl_point)
+         tl_lat1=iom_mpp_read_var(tl_coord1, TRIM(cl_name))
          
-         !3- compute
-         grid_get_coarse_index_cf(:,:,:)=grid_get_coarse_index(td_lon0,td_lat0,&
-         &                                                     tl_lon1,tl_lat1,&
-         &                                                     il_rho(:) )
-
+         CALL grid_del_ghost(tl_lon1, il_xghost(:,:))
+         CALL grid_del_ghost(tl_lat1, il_xghost(:,:))
+
+         ! close mpp files
+         CALL iom_mpp_close(tl_coord1)
+
+         ! compute
+         grid__get_coarse_index_cf(:,:)=grid_get_coarse_index(td_lon0,td_lat0,&
+         &                                                    tl_lon1,tl_lat1,&
+         &                                                    il_rho(:), cl_point )
+
+         
          CALL var_clean(tl_lon1)
          CALL var_clean(tl_lat1)         
@@ -768,36 +2230,47 @@
       ENDIF
 
-   END FUNCTION grid_get_coarse_index_cf
-   !> @endcode
+      DEALLOCATE(il_rho)
+      CALL mpp_clean(tl_coord1)
+
+   END FUNCTION grid__get_coarse_index_cf
    !-------------------------------------------------------------------
    !> @brief This function get closest coarse grid indices of fine grid domain.
    !
    !> @details
-   !>
-   !> @warning use ghost cell so can not be used on extracted domain without
-   !> ghost cell
-   !
+   !> it use coarse grid coordinates file and fine grid array of longitude and latitude.
+   !> optionaly, you could specify the array of refinment factor (default 1.)
+   !> optionally, you could specify on which Arakawa grid point you want to
+   !> work (default 'T')
+   !>
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] td_coord0 : coarse grid coordinate structure
-   !> @param[in] td_lon1 : fine grid longitude
-   !> @param[in] td_lat1 : fine grid latitude
-   !> @return coarse grid indices (/ (/imin0, imax0/), (/jmin0, jmax0/) /)
-   !-------------------------------------------------------------------
-   !> @code
-   FUNCTION grid_get_coarse_index_fc( td_coord0, td_lon1, td_lat1, &
-   &                                  id_rho )
+   !> - November, 2013- Initial Version
+   !> @date September, 2014
+   !> - use grid point to read coordinates variable.
+   !> @date October, 2014
+   !> - work on mpp file structure instead of file structure
+   !> 
+   !> @param[in] td_coord0 coarse grid coordinate mpp structure
+   !> @param[in] td_lon1   fine grid longitude
+   !> @param[in] td_lat1   fine grid latitude
+   !> @param[in] id_rho    array of refinment factor (default 1.)
+   !> @param[in] cd_point  Arakawa grid point (default 'T')
+   !> @return coarse grid indices (/(/imin0, imax0/), (/jmin0, jmax0/)/)
+   !-------------------------------------------------------------------
+   FUNCTION grid__get_coarse_index_fc( td_coord0, td_lon1, td_lat1, &
+   &                                  id_rho, cd_point )
       IMPLICIT NONE
       ! Argument
-      TYPE(TFILE), INTENT(IN) :: td_coord0
-      TYPE(TVAR ), INTENT(IN) :: td_lon1
-      TYPE(TVAR ), INTENT(IN) :: td_lat1
-      INTEGER(i4), DIMENSION(:), INTENT(IN), OPTIONAL :: id_rho
+      TYPE(TMPP )                   , INTENT(IN) :: td_coord0
+      TYPE(TVAR )                   , INTENT(IN) :: td_lon1
+      TYPE(TVAR )                   , INTENT(IN) :: td_lat1
+      INTEGER(i4)     , DIMENSION(:), INTENT(IN), OPTIONAL :: id_rho
+      CHARACTER(LEN=*)              , INTENT(IN), OPTIONAL :: cd_point
 
       ! function
-      INTEGER(i4), DIMENSION(2,2,2) :: grid_get_coarse_index_fc
+      INTEGER(i4), DIMENSION(2,2) :: grid__get_coarse_index_fc
 
       ! local variable
+      TYPE(TMPP)  :: tl_coord0
+
       TYPE(TVAR)  :: tl_lon0
       TYPE(TVAR)  :: tl_lat0
@@ -805,7 +2278,5 @@
       INTEGER(i4), DIMENSION(:), ALLOCATABLE :: il_rho
 
-      INTEGER(i4), DIMENSION(ip_maxdim) :: il_start
-      INTEGER(i4), DIMENSION(ip_maxdim) :: il_count
-      INTEGER(i4), DIMENSION(2)         :: il_xghost
+      INTEGER(i4), DIMENSION(2,2)       :: il_xghost
 
       INTEGER(i4) :: il_imin0
@@ -814,4 +2285,6 @@
       INTEGER(i4) :: il_jmax0
 
+      CHARACTER(LEN= 1) :: cl_point
+      CHARACTER(LEN=lc) :: cl_name      
 
       ! loop indices
@@ -819,13 +2292,19 @@
 
       ! init
-      grid_get_coarse_index_fc(:,:,:)=0
-
-      ALLOCATE(il_rho(ig_ndim))
+      grid__get_coarse_index_fc(:,:)=0
+
+      ALLOCATE(il_rho(ip_maxdim))
       il_rho(:)=1
       IF( PRESENT(id_rho) ) il_rho(:)=id_rho(:)
 
-      IF( td_coord0%i_id == 0 )THEN
-         CALL logger_error("GRID GET COARSE INDEX: file "//&
-         &                 TRIM(td_coord0%c_name)//" not opened." )
+      cl_point='T'
+      IF( PRESENT(cd_point) ) cl_point=TRIM(fct_upper(cd_point))
+
+      ! copy structure
+      tl_coord0=mpp_copy(td_coord0)
+
+      IF( .NOT. ASSOCIATED(tl_coord0%t_proc) )THEN
+         CALL logger_error("GRID GET COARSE INDEX: decompsition of mpp "//&
+         &  "file "//TRIM(tl_coord0%c_name)//" not defined." )
 
       ELSE IF( .NOT. ASSOCIATED(td_lon1%d_value) .OR. &
@@ -836,83 +2315,95 @@
 
       ELSE
+
+         IF( TRIM(td_lon1%c_point)/='' )THEN
+            cl_point=TRIM(td_lon1%c_point)
+         ELSEIF( TRIM(td_lat1%c_point)/='' )THEN
+            cl_point=TRIM(td_lat1%c_point)
+         ENDIF
+
+         ! get ghost cell factor on coarse grid
+         il_xghost(:,:)=grid_get_ghost( tl_coord0 )
+
+         ! open mpp files
+         CALL iom_mpp_open(tl_coord0)
+
          ! read coarse longitue and latitude
-         tl_lon0=iom_read_var(td_coord0,'longitude')
-         tl_lat0=iom_read_var(td_coord0,'latitude')
-
-         ! get ghost cell factor on coarse grid
-         il_xghost(:)=grid_get_ghost( tl_lon0, tl_lat0 )
-
-         il_imin0=1+il_xghost(1)*ig_ghost
-         il_jmin0=1+il_xghost(2)*ig_ghost
-
-         il_imax0=tl_lon0%t_dim(1)%i_len-il_xghost(1)*ig_ghost
-         il_jmax0=tl_lon0%t_dim(2)%i_len-il_xghost(2)*ig_ghost
+         WRITE(cl_name,*) 'longitude_'//TRIM(cl_point)
+         tl_lon0=iom_mpp_read_var(tl_coord0, TRIM(cl_name))
+         WRITE(cl_name,*) 'latitude_'//TRIM(cl_point)
+         tl_lat0=iom_mpp_read_var(tl_coord0, TRIM(cl_name))
+
+         CALL grid_del_ghost(tl_lon0, il_xghost(:,:))
+         CALL grid_del_ghost(tl_lat0, il_xghost(:,:))
+
+         ! close mpp files
+         CALL iom_mpp_close(tl_coord0)
+
+         grid__get_coarse_index_fc(:,:)=grid_get_coarse_index(tl_lon0,tl_lat0,&
+         &                                                    td_lon1,td_lat1,&
+         &                                                    il_rho(:), cl_point )
+
+         ! remove ghost cell
+         il_imin0=grid__get_coarse_index_fc(1,1)+il_xghost(jp_I,1)*ip_ghost
+         il_imax0=grid__get_coarse_index_fc(1,2)+il_xghost(jp_I,1)*ip_ghost
+
+         il_jmin0=grid__get_coarse_index_fc(2,1)+il_xghost(jp_J,1)*ip_ghost
+         il_jmax0=grid__get_coarse_index_fc(2,2)+il_xghost(jp_J,1)*ip_ghost
+
+         grid__get_coarse_index_fc(1,1)=il_imin0
+         grid__get_coarse_index_fc(1,2)=il_imax0
+         grid__get_coarse_index_fc(2,1)=il_jmin0
+         grid__get_coarse_index_fc(2,2)=il_jmax0
 
          CALL var_clean(tl_lon0)
          CALL var_clean(tl_lat0)
 
-         ! read coarse longitue and latitude without ghost cell
-         il_start(:)=(/il_imin0,il_jmin0,1,1/)
-         il_count(:)=(/il_imax0-il_imin0+1, &
-         &             il_jmax0-il_jmin0+1, &
-         &             tl_lon0%t_dim(3)%i_len, &
-         &             tl_lon0%t_dim(4)%i_len /)
-
-         tl_lon0=iom_read_var(td_coord0,'longitude',il_start(:), il_count(:))
-         tl_lat0=iom_read_var(td_coord0,'latitude' ,il_start(:), il_count(:))
-
-         grid_get_coarse_index_fc(:,:,:)=grid_get_coarse_index(tl_lon0,tl_lat0,&
-         &                                                     td_lon1,td_lat1,&
-         &                                                     il_rho(:) )
-
-         ! remove ghost cell
-         il_imin0=grid_get_coarse_index_fc(1,1,1)+il_xghost(1)*ig_ghost
-         il_imax0=grid_get_coarse_index_fc(1,2,1)+il_xghost(1)*ig_ghost
-         il_jmin0=grid_get_coarse_index_fc(2,1,1)+il_xghost(2)*ig_ghost
-         il_jmax0=grid_get_coarse_index_fc(2,2,1)+il_xghost(2)*ig_ghost
-
-         grid_get_coarse_index_fc(1,1,1)=il_imin0
-         grid_get_coarse_index_fc(1,2,1)=il_imax0
-         grid_get_coarse_index_fc(2,1,1)=il_jmin0
-         grid_get_coarse_index_fc(2,2,1)=il_jmax0
-
-         CALL var_clean(tl_lon0)
-         CALL var_clean(tl_lat0)
-
-      ENDIF
-
-   END FUNCTION grid_get_coarse_index_fc
-   !> @endcode
+      ENDIF
+
+      CALL mpp_clean(tl_coord0)
+      DEALLOCATE(il_rho)
+
+   END FUNCTION grid__get_coarse_index_fc
    !-------------------------------------------------------------------
    !> @brief This function get closest coarse grid indices of fine grid domain.
    !
    !> @details
-   !>
-   !> @warning use ghost cell so can not be used on extracted domain without
-   !> ghost cell
-   !
+   !> it use coarse and fine grid array of longitude and latitude.
+   !> optionaly, you could specify the array of refinment factor (default 1.)
+   !> optionally, you could specify on which Arakawa grid point you want to
+   !> work (default 'T')
+   !>
+   !> @note do not use ghost cell
+   !>
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] td_lon0 : coarse grid longitude
-   !> @param[in] td_lat0 : coarse grid latitude
-   !> @param[in] td_lon1 : fine grid longitude
-   !> @param[in] td_lat1 : fine grid latitude
-   !> @return coarse grid indices (/ (/imin0, imax0/), (/jmin0, jmax0/) /)
-   !>
-   !-------------------------------------------------------------------
-   !> @code
-   FUNCTION grid_get_coarse_index_cc( td_lon0, td_lat0, td_lon1, td_lat1, &
-   &                                  id_rho )
+   !> - November, 2013- Initial Version
+   !> @date September, 2014
+   !> - check grid point
+   !> - take into account EW overlap
+   !>
+   !> @param[in] td_lon0   coarse grid longitude
+   !> @param[in] td_lat0   coarse grid latitude
+   !> @param[in] td_lon1   fine grid longitude
+   !> @param[in] td_lat1   fine grid latitude
+   !> @param[in] id_rho    array of refinment factor
+   !> @param[in] cd_point  Arakawa grid point ('T','U','V','F')
+   !> @return coarse grid indices (/(/imin0, imax0/), (/jmin0, jmax0/)/)
+   !>
+   !> @todo
+   !> -check case boundary domain on overlap band
+   !-------------------------------------------------------------------
+   FUNCTION grid__get_coarse_index_cc( td_lon0, td_lat0, td_lon1, td_lat1, &
+   &                                   id_rho, cd_point )
       IMPLICIT NONE
       ! Argument
-      TYPE(TVAR) , INTENT(IN) :: td_lon0
-      TYPE(TVAR) , INTENT(IN) :: td_lat0
-      TYPE(TVAR) , INTENT(IN) :: td_lon1
-      TYPE(TVAR) , INTENT(IN) :: td_lat1
-      INTEGER(i4), DIMENSION(:), INTENT(IN), OPTIONAL :: id_rho
+      TYPE(TVAR)                    , INTENT(IN) :: td_lon0
+      TYPE(TVAR)                    , INTENT(IN) :: td_lat0
+      TYPE(TVAR)                    , INTENT(IN) :: td_lon1
+      TYPE(TVAR)                    , INTENT(IN) :: td_lat1
+      INTEGER(i4)     , DIMENSION(:), INTENT(IN), OPTIONAL :: id_rho
+      CHARACTER(LEN=*)              , INTENT(IN), OPTIONAL :: cd_point
 
       ! function
-      INTEGER(i4), DIMENSION(2,2,2) :: grid_get_coarse_index_cc
+      INTEGER(i4), DIMENSION(2,2) :: grid__get_coarse_index_cc
 
       ! local variable
@@ -927,7 +2418,4 @@
       REAL(dp)    :: dl_lat1_ur
 
-      REAL(dp)    :: dl_dlon
-      REAL(dp)    :: dl_dlat
-
       INTEGER(i4), DIMENSION(:), ALLOCATABLE :: il_rho
 
@@ -954,18 +2442,35 @@
       INTEGER(i4) :: il_jmax      
 
-      INTEGER(i4), DIMENSION(2,2) :: il_offset
-
+      INTEGER(i4), DIMENSION(2,2) :: il_xghost0
+      INTEGER(i4), DIMENSION(2,2) :: il_yghost0
+      INTEGER(i4), DIMENSION(2,2) :: il_xghost1
+      INTEGER(i4), DIMENSION(2,2) :: il_yghost1
+
+      TYPE(TVAR) :: tl_lon0
+      TYPE(TVAR) :: tl_lat0
+      TYPE(TVAR) :: tl_lon1
+      TYPE(TVAR) :: tl_lat1
+
+      CHARACTER(LEN= 1) :: cl_point0
+      CHARACTER(LEN= 1) :: cl_point1
+      
       ! loop indices
       INTEGER(i4) :: ji
       INTEGER(i4) :: jj
       !----------------------------------------------------------------
-
       ! init
-      grid_get_coarse_index_cc(:,:,:)=0
-
-      ALLOCATE( il_rho(ig_ndim) )
+      grid__get_coarse_index_cc(:,:)=0
+
+      ALLOCATE( il_rho(ip_maxdim) )
       il_rho(:)=1
       IF( PRESENT(id_rho) ) il_rho(:)=id_rho(:)
 
+      cl_point0='T'
+      cl_point1='T'
+      IF( PRESENT(cd_point) )THEN
+         cl_point0=TRIM(fct_upper(cd_point))
+         cl_point1=TRIM(fct_upper(cd_point))
+      ENDIF
+      
       IF( .NOT. ASSOCIATED(td_lon0%d_value) .OR. &
       &   .NOT. ASSOCIATED(td_lat0%d_value) .OR. &
@@ -976,10 +2481,25 @@
       ELSE
 
+         IF( TRIM(td_lon0%c_point)/='' )THEN
+            cl_point0=TRIM(td_lon0%c_point)
+         ELSEIF( TRIM(td_lat0%c_point)/='' )THEN
+            cl_point0=TRIM(td_lat0%c_point)
+         ENDIF
+         IF( TRIM(td_lon1%c_point)/='' )THEN
+            cl_point1=TRIM(td_lon1%c_point)
+         ELSEIF( TRIM(td_lat1%c_point)/='' )THEN
+            cl_point1=TRIM(td_lat1%c_point)
+         ENDIF
+         IF( cl_point0 /= cl_point1 )THEN
+            CALL logger_error("GRID GET COARSE INDEX: fine and coarse grid"//&
+         &                 " coordinate not on same grid point.")
+         ENDIF
+
          IF( grid_is_global(td_lon1, td_lat1) )THEN
 
             IF( grid_is_global(td_lon0, td_lat0) )THEN
                CALL logger_trace("GRID GET COARSE INDEX: fine grid is global ")
-               grid_get_coarse_index_cc(:,:,1) = 1
-               grid_get_coarse_index_cc(:,:,2) = 0
+               grid__get_coarse_index_cc(:,:) = 1
+               grid__get_coarse_index_cc(:,:) = 0
             ELSE
                CALL logger_error("GRID GET COARSE INDEX: fine grid is "//&
@@ -989,13 +2509,25 @@
          ELSE
 
+            il_xghost0(:,:)=grid_get_ghost( td_lon0 )
+            il_yghost0(:,:)=grid_get_ghost( td_lat0 )
+            IF( ANY(il_xghost0(:,:) /= il_yghost0(:,:)) )THEN
+               CALL logger_error("GRID GET COARSE INDEX: coarse grid "//&
+               &        "coordinate do not share same ghost cell")
+            ENDIF
+
+            tl_lon0=var_copy(td_lon0)
+            tl_lat0=var_copy(td_lat0)
+            CALL grid_del_ghost(tl_lon0, il_xghost0(:,:))
+            CALL grid_del_ghost(tl_lat0, il_xghost0(:,:))
+            
             ! "global" coarse grid indice
             il_imin0=1
             il_jmin0=1
 
-            il_imax0=td_lon0%t_dim(1)%i_len
-            il_jmax0=td_lon0%t_dim(2)%i_len
+            il_imax0=tl_lon0%t_dim(1)%i_len
+            il_jmax0=tl_lon0%t_dim(2)%i_len
 
             ! get east west overlap for coarse grid
-            il_ew0=dom_get_ew_overlap(td_lon0)
+            il_ew0=tl_lon0%i_ew
             IF( il_ew0 >= 0 )THEN
                ! last point before overlap
@@ -1003,13 +2535,25 @@
             ENDIF
 
+            il_xghost1(:,:)=grid_get_ghost( td_lon1 )
+            il_yghost1(:,:)=grid_get_ghost( td_lat1 )
+            IF( ANY(il_xghost1(:,:) /= il_yghost1(:,:)) )THEN
+               CALL logger_error("GRID GET COARSE INDEX: fine grid "//&
+               &        "coordinate do not share same ghost cell")
+            ENDIF
+
+            tl_lon1=var_copy(td_lon1)
+            tl_lat1=var_copy(td_lat1)
+            CALL grid_del_ghost(tl_lon1, il_xghost1(:,:))
+            CALL grid_del_ghost(tl_lat1, il_xghost1(:,:))
+            
             ! "global" fine grid indice
             il_imin1=1
             il_jmin1=1
 
-            il_imax1=td_lon1%t_dim(1)%i_len
-            il_jmax1=td_lon1%t_dim(2)%i_len
-
-            ! get east west overlap for coarse grid
-            il_ew1=dom_get_ew_overlap(td_lon1)
+            il_imax1=tl_lon1%t_dim(1)%i_len
+            il_jmax1=tl_lon1%t_dim(2)%i_len
+
+            ! get east west overlap for fine grid
+            il_ew1=tl_lon1%i_ew
             IF( il_ew1 >= 0 )THEN
                ! last point before overlap
@@ -1019,30 +2563,18 @@
             ! get indices for each corner
             !1- search lower left corner indices
-            dl_lon1_ll=td_lon1%d_value( il_imin1, il_jmin1, 1, 1 )
-            dl_lat1_ll=td_lat1%d_value( il_imin1, il_jmin1, 1, 1 )
-
-            dl_dlon=ABS(td_lon1%d_value(il_imin1+1,il_jmin1  ,1,1)-dl_lon1_ll)
-            dl_dlat=ABS(td_lat1%d_value(il_imin1  ,il_jmin1+1,1,1)-dl_lat1_ll)
-
-!            CALL logger_debug("GRID GET COARSE INDEX: lon1 ll "//&
-!            &  TRIM(fct_str(dl_lon1_ll)) )
-!            CALL logger_debug("GRID GET COARSE INDEX: lat1 ll "//&
-!            &  TRIM(fct_str(dl_lat1_ll)) )
-!
-!            CALL logger_debug("GRID GET COARSE INDEX: lon0 min "//&
-!            &  TRIM(fct_str(minval(td_lon0%d_value(2:,2:,:,:)))) )
-!            CALL logger_debug("GRID GET COARSE INDEX: lon0 max "//&
-!            &  TRIM(fct_str(maxval(td_lon0%d_value(2:,2:,:,:)))) )
-!
-!            CALL logger_debug("GRID GET COARSE INDEX: lat0 min "//&
-!            &  TRIM(fct_str(minval(td_lat0%d_value(2:,2:,:,:)))) )
-!            CALL logger_debug("GRID GET COARSE INDEX: lat0 max "//&
-!            &  TRIM(fct_str(maxval(td_lat0%d_value(2:,2:,:,:)))) )
-
+            dl_lon1_ll=tl_lon1%d_value( il_imin1, il_jmin1, 1, 1 )
+            dl_lat1_ll=tl_lat1%d_value( il_imin1, il_jmin1, 1, 1 )
+
+            IF( dl_lon1_ll == tl_lon1%d_fill .OR. &
+            &   dl_lat1_ll == tl_lat1%d_fill )THEN
+               CALL logger_error("GRID GET COARSE INDEX: lower left corner "//&
+               &                 "point is FillValue. remove ghost cell "//&
+               &                 "before running grid_get_coarse_index.")
+            ENDIF
             ! look for closest point on coarse grid
-            il_ill(:)= grid_get_closest(td_lon0%d_value(il_imin0:il_imax0, &
+            il_ill(:)= grid_get_closest(tl_lon0%d_value(il_imin0:il_imax0, &
             &                                           il_jmin0:il_jmax0, &
             &                                           1,1), &
-            &                           td_lat0%d_value(il_imin0:il_imax0, &
+            &                           tl_lat0%d_value(il_imin0:il_imax0, &
             &                                           il_jmin0:il_jmax0, &
             &                                           1,1), &
